import bpy
from bpy import *

import mathutils
from mathutils import *
from math import *

from .BB267___COMMONS import *
from .BB267___VIEW import *


bpy.types.Object.BBInfo = bpy.props.StringProperty()


class bb_operator_interactive(types.Operator):
	bl_idname = "ops.bb_operator_interactive"
	bl_label = "Run in Game Engine"
	bl_description = "Enter Interactive View Mode"
	def invoke(self, context, event):
		try:
			if "ShapeIndexedFaceSet" in bpy.data.objects.keys():
				bpy.data.objects['ShapeIndexedFaceSet'].select = True
				bpy.context.scene.objects.active = bpy.data.objects['ShapeIndexedFaceSet']
				bpy.ops.object.delete(use_global=False)
		except Exception as E:
			print("No ShapeIndexedFaceSet in scene (or renamed...)")
		finally:
			try:
				if(bpy.context.scene.BBViewFilter=="4"):
					bpy.context.scene.BBViewFilter="3"
					updateView()
				geStart()
			except Exception as E:
				s = "Start Game Failed: " + str(E)
				print(s)
				return {'CANCELLED'}
			else:
				return{'FINISHED'}
bpy.utils.register_class(bb_operator_interactive)


def geStart():
	tmpFPS = bpy.context.scene.render.fps
	bpy.context.scene.render.fps = 1
	bpy.context.scene.game_settings.fps = bpy.context.scene.render.fps
	if bpy.context.scene.BBSolveMotion == 0:
		bpy.context.scene.game_settings.physics_engine = "NONE"
	if bpy.context.scene.BBSolveMotion > 0:
		bpy.context.scene.game_settings.physics_engine = "BULLET"
		bpy.context.scene.game_settings.logic_step_max = 1
	if bpy.context.vertex_paint_object:
		bpy.ops.paint.vertex_paint_toggle()
	for i, obj in enumerate(bpy.data.objects):
		obj.game.radius=bpy.context.scene.BBDeltaPhysicRadius
	setViewShading("TEXTURED")
	bpy.context.scene.render.engine='BLENDER_GAME'
	bpy.context.scene.game_settings.physics_gravity = 0.0
	bpy.ops.view3d.game_start()
	setViewShading("SOLID")
	bpy.context.scene.render.fps = tmpFPS


if __name__ == "__main__":
	print("GE module created")