import bpy
from bpy import *
from urllib.parse import urlencode
from urllib.request import *
from html.parser import *
from smtplib import *
from email.mime.text import MIMEText
import time, platform, os
import codecs
import bpy.path
from bpy.path import abspath
import base64
import mathutils
from mathutils import *
from math import *
import pickle
import shutil
import subprocess


from .BB267___COMMONS import *
from .BB267___VIEW import *
from .BB267___PDBimport import *		


bpy.types.Object.BBInfo = bpy.props.StringProperty()


class bb_operator_nma(types.Operator):
	bl_idname = "ops.bb_operator_nma"
	bl_label = "Calculate NMA trajectories (pdb)"
	bl_description = "Calculate Normal Mode Analysis Trajectories"
	def invoke(self, context, event):
		global importReady
		try:
			bpy.context.user_preferences.edit.use_global_undo = False
			computeNormalModeTrajectories()
			bpy.context.user_preferences.edit.use_global_undo = True
		except Exception as E:
			s = "Normal Mode Analysis Calculate Failed: " + str(E)
			print(s)
			return {'CANCELLED'}
		else:
			return{'FINISHED'}
bpy.utils.register_class(bb_operator_nma)


def computeNormalModeTrajectories() : 
	name = bpy.context.scene.BBModelRemark
	inputpath = abspath(bpy.context.scene.BBImportPath)
	if os.path.isfile(inputpath) : 
		modestr = bpy.context.scene.BBNormalModeAnalysis
		mode = int(modestr)+1
		struct = "--all"
		name = bpy.context.scene.BBModelRemark
		rmsd = bpy.context.scene.BBNMARMSD
		gamma = bpy.context.scene.BBNMAGamma
		cutoff = bpy.context.scene.BBNMACutoff		 
		nbconfiguration = bpy.context.scene.BBNMANbModel
		
		outputpath = homePath + "fetched" + os.sep +name+"_"+"Mode"+str(mode)+"_"+struct+"_"+str(rmsd)+"_"+str(nbconfiguration)+".pdb"
		
		file = open(outputpath, 'w+')
		file.close()
		
		if linux:
			command = "chmod 755 %s" % (quotedPath(homePath + "bin" + os.sep + "nma" + os.sep + "nma.py"))
			command = quotedPath(command)
			p = launch(exeName=command, async = False)
		command = "%s %s -i %s -o %s -m %d -r %f -n %d %s " % (quotedPath(pyPath), quotedPath(homePath + "bin" + os.sep + "nma" + os.sep + "nma.py"), quotedPath(inputpath), quotedPath(outputpath), mode, rmsd, nbconfiguration, struct)
		
		p = launch(exeName=command, async = False)
		bpy.context.scene.BBImportPath = outputpath
		importPreview()
	else : 
		print("File does not exist !!")


if __name__ == "__main__":
	print("NMA module created")